/* 
 *	Panel and widgets common for "Command Execution" and 
 *	"User Authentication" panels.
 */

#include "launch.h"

/*
 *	Creating Launch panel
 */
void
createCommonPanel (void)
{
  RColor color;

  LaunchPanel->window = WMCreateWindowWithStyle (wm_screen, "Launch",
												 WMTitledWindowMask);

  WMResizeWidget (LaunchPanel->window, 324, 234);
  WMSetWindowTitle (LaunchPanel->window, "");
  WMRealizeWidget (LaunchPanel->window);
  app = WMAppCreateWithMain (display, DefaultScreen (display),
							 WMWidgetXID (LaunchPanel->window));

  WMSetWindowInitialPosition (LaunchPanel->window, (WidthOfScreen
													(DefaultScreenOfDisplay (display)) -
													WMWidgetWidth (LaunchPanel->window)) / 2,
							  (HeightOfScreen (DefaultScreenOfDisplay (display)) -
							   WMWidgetHeight (LaunchPanel->window)) / 4);

  /* icon on the upleft side */
  color.red = 0xae;
  color.green = 0xaa;
  color.blue = 0xae;
  color.alpha = 0;

  LaunchPanel->icon_pixmap = WMCreateBlendedPixmapFromFile (wm_screen,
															PREFIX "/Launch.app/Launch.tiff", &color);
  LaunchPanel->icon_label = WMCreateLabel (LaunchPanel->window);
  WMResizeWidget (LaunchPanel->icon_label, 48, 48);
  WMMoveWidget (LaunchPanel->icon_label, 8, 8);
  WMSetLabelImage (LaunchPanel->icon_label, LaunchPanel->icon_pixmap);
  WMSetLabelImagePosition (LaunchPanel->icon_label, WIPImageOnly);

  /* title label */
  LaunchPanel->title_font = WMCreateFont (wm_screen,
										  "-*-helvetica-medium-r-*-*-*-180-*-*-*-*-*-*");
  LaunchPanel->title = WMCreateLabel (LaunchPanel->window);
  WMResizeWidget (LaunchPanel->title, 214, 48);
  WMMoveWidget (LaunchPanel->title, 64, 8);
  WMSetLabelFont (LaunchPanel->title, LaunchPanel->title_font);
  WMReleaseFont (LaunchPanel->title_font);

  /* horizontal line */
  LaunchPanel->hr_line = WMCreateFrame (LaunchPanel->window);
  WMResizeWidget (LaunchPanel->hr_line, 324, 2);
  WMMoveWidget (LaunchPanel->hr_line, 0, 64);

  /* info label */
  LaunchPanel->info = WMCreateLabel (LaunchPanel->window);
  WMResizeWidget (LaunchPanel->info, 324, 14);
  WMMoveWidget (LaunchPanel->info, 0, 80);
  WMSetLabelTextAlignment (LaunchPanel->info, WACenter);
}

/*
 *	Setting window manager's hints for Launch panel
 */
void
configureCommonPanel (void)
{
  GNUstepWMAttributes attr;
  XWMHints *wmhints;
  XClassHint *wclass;

  if ((wclass = XAllocClassHint ()))
	{
	  wclass->res_name = "launch";
	  wclass->res_class = "Launch";
	  XSetClassHint (display, WMWidgetXID (LaunchPanel->window), wclass);
	}

  memset ((void *) &attr, 0, sizeof (GNUstepWMAttributes));
  //	attr.window_level = WMNormalWindowLevel;
  attr.window_level = WMModalPanelWindowLevel;
  attr.window_style = WMTitledWindowMask;
  attr.flags = (GSWindowLevelAttr | GSWindowStyleAttr);
  WMSetWindowAttributes (display, WMWidgetXID (LaunchPanel->window), &attr);

  if ((wmhints = XAllocWMHints ()))
	{
	  wmhints->window_group = WMWidgetXID (LaunchPanel->window);
	  wmhints->flags = WindowGroupHint;
	  XSetWMHints (display, WMWidgetXID (LaunchPanel->window), wmhints);
	}
}
