/*
 *	Command execution in action. fork(), exec() and so on.
 */

#include "launch.h"
#include <pwd.h>

extern char **environ;

/*
 *	Replacing the "%s" string
 */
void
replace_par (char *out_string, char *tmp_string)
{
  int		str_pos = 0, rep_enl = 1;
  char	*end_temp, *in_string;

  in_string = (char *) malloc (256);
  strcpy (in_string, out_string);

  while (rep_enl)
	{
	  while ((tmp_string[str_pos] != '%') && str_pos != strlen (tmp_string))
		str_pos++;
	  {
		if (str_pos != strlen (tmp_string) && (tmp_string[str_pos + 1] != 's'
											   || tmp_string[str_pos + 1] != 'S'))
		  {
			if (strlen (tmp_string) == str_pos + 2)
			  {
				tmp_string[str_pos] = '\0';
				strcat (tmp_string, out_string);
				strcpy (in_string, tmp_string);
				rep_enl = 0;
			  }
			else
			  {
				end_temp = (char *) malloc (256);
				strcpy (end_temp, tmp_string + str_pos + 2);
				tmp_string[str_pos] = '\0';
				strcat (tmp_string, out_string);
				strcat (tmp_string, end_temp);
				strcpy (in_string, tmp_string);
				free (end_temp);
			  }
		  }
		else
		  {
			rep_enl = 0;
		  }
		str_pos = 0;
	  }
	}
  strcpy (out_string, in_string);
  free (in_string);
}

/*
 *  putenv() wrapper
 */

static void
setEnv (char *ev, char *val, int rewrite)
{
  char *temp;

  /* temp is not freed later because it's environment member */
  temp = (char *)calloc(strlen(ev)+strlen(val), sizeof(char*));

  if (rewrite)
	{ 
	  strncpy (temp, ev, strlen(ev));
	  strcat (temp, "=");
	  strncat (temp, val, strlen(val));
/* 	  fprintf(stderr, "%s\n", temp); */
	  if (putenv (temp) == -1)
		fprintf(stderr, "putenv() error\n");
	}
}

/*
 *	Command execution
 */
void
runCommand (void)
{
  char *exec_argv[100];
  char *entered_temp;
  int  i, arg_num = 0, str_pos = 0, str_bot = 0;
  int  pid, exctrl_ret;

  /* initialize vars */
  entered_temp = (char *) malloc (1024);
  entered_temp[0] = '\0';
  for (i = 0; i <= 20; i++)
	{
	  exec_argv[i] = (char *) malloc (256);
	}
	
  if (!strncmp (entered_text, "http:", 5) || !strncmp (entered_text, "www.", 4))
	{
	  /* Replace %s with your entered text */
	  strcpy (entered_temp, WMGetUDStringForKey (udb, "HTTP_App"));
	  replace_par (entered_text, entered_temp);
	}

  if (!strncmp (entered_text, "ftp:", 4) || !strncmp (entered_text, "ftp.", 4))
	{
	  /* Replace %s with your entered text */
	  strcpy (entered_temp, WMGetUDStringForKey (udb, "FTP_App"));
	  replace_par (entered_text, entered_temp);
	}
	
  if (ConsoleApp)
	{
	  strcpy (entered_temp, WMGetUDStringForKey (udb, "Term_Com"));
	  replace_par (entered_text, entered_temp);
	}

  entered_temp[0] = '\0';

  /* Home var !!!*/
  if (entered_text[0] == '~')
	{
	  strcpy (entered_temp, entered_text + 1);
	  strcpy (entered_text, home_var);
	  strcat (entered_text, "/");
	  strcat (entered_text, entered_temp);
	}
  free (entered_temp);

  /* fill arguments list*/
  while (entered_text[str_pos] != '\0')
	{
	  i = 0;
	  while (entered_text[str_pos] != ' ' && entered_text[str_pos] != '\0')
		{
		  str_pos++;
		  i++;
		}
	  if (entered_text[str_pos] == ' ' || entered_text[str_pos] == '\0')
		{
		  strncpy (exec_argv[arg_num], entered_text + str_bot, i);
		  exec_argv[arg_num][i] = '\0';
		  str_bot = str_pos;
		  arg_num++;
		  if (entered_text[str_pos] == ' ')
			{
			  str_bot++;
			  str_pos++;
			}
		  if (entered_text[str_pos] == '\0')
			break;
		}
	}

  /* test permission */
  exctrl_ret = testFile (exec_argv[0]);
  if (exctrl_ret == 1)
	{
	  SMRunAttentionPanel (wm_screen, LaunchPanel->window,
						   "Command Execution error", 
						   "Permission denied.", NULL, NULL, "Ok");
	  exit (0);
	}
  else if (exctrl_ret == 2)
	{
	  SMRunAttentionPanel (wm_screen, LaunchPanel->window,
						   "Command Execution error", 
						   "Unknown error.", NULL, NULL, "Ok");
	  exit (0);
	}
  else if (exctrl_ret == 3)
	{
	  SMRunAttentionPanel (wm_screen, LaunchPanel->window,
						   "Command Execution error", 
						   "Command not found.", NULL, NULL, "Ok");
	  exit (0);
	}

  /* fork-exec */
  exec_argv[arg_num] = NULL;
  pid = fork ();
  if (pid == 0)
	{
	  char **cleanenv;
	  char *envDisplay;

	  /* set group first */
	  if (setgid (pw->pw_gid) || setegid(pw->pw_gid))
		{
		  SMRunAttentionPanel (wm_screen, LaunchPanel->window,
							   "Command Execution error", 
							   "Unable to set group ID.", NULL, NULL, "Ok");
		}
	  
	  /* then user */
	  if (setuid (pw->pw_uid) || seteuid(pw->pw_uid))
		{
		  SMRunAttentionPanel (wm_screen, LaunchPanel->window,
							   "Command Execution error",
							   "Unable to set user ID.", NULL, NULL, "Ok");
		}

	  if (WMGetUDBoolForKey(WMGetStandardUserDefaults(), "PreserveEnvironment") == False)
		{
		  /* save env variables*/
		  envDisplay = getenv("DISPLAY");

		  /* Free **environ */
		  if ((cleanenv = calloc(20, sizeof(char*))) == NULL)
			fprintf(stderr, "calloc");

		  cleanenv[0] = NULL;
		  environ = cleanenv;

		  /* Set env vars */
		  /* 	  fprintf(stderr, "uid: %i gid: %i\n", pw->pw_uid, pw->pw_gid); */
		  setEnv("PATH", path, 1);
		  setEnv("TERM", "xterm", 1);
		  setEnv("HOME", pw->pw_dir, 1);
		  setEnv("SHELL", pw->pw_shell, 1);
		  setEnv("USER", pw->pw_name, 1);
		  setEnv("USERNAME", pw->pw_name, 1);
		  setEnv("LOGNAME", pw->pw_name, 1);
		  setEnv("DISPLAY", envDisplay, 1);
		}

 	  chdir(pw->pw_dir);

	  if (execvp (exec_argv[0], exec_argv) == -1)
		{
		  SMRunAttentionPanel (wm_screen, LaunchPanel->window,
							   "Command Execution error", strerror(errno),
							   NULL, NULL, "Ok");
		}
	  exit (0);
	}
  
  for (i = 0; i <= 20; i++)
	{
	  free (exec_argv[i]);
	}
}
