/*
 *	Functions for retrieving and storing command history
 */

#include "launch.h"

void
loadHistory (void)
{
  int  history_file;
  char *read_char;
  char *read_line;
  char *wmrun_dir;
  int  cur_char = 0, cur_file_pos = 0, i;

  /* setting up all variables */
  read_char = (char *) malloc (2);
  read_line = (char *) malloc (256);	//64
  wmrun_dir = (char *) malloc (64);
  if (read_char == NULL || read_line == NULL)
	{
	  fprintf (stderr, "Couldn't allocate memory!\n");
	  exit (1);
	}

  for (i = 0; i <= COMMANDS_NUMBER; i++)
	{
	  command_history[i] = (char *) malloc (256);	//64
	}
	
  /* reading History file */
  strcpy (wmrun_dir, home_var);
  strcat (wmrun_dir, "/GNUstep/.AppInfo/Launch");
  mkdir (wmrun_dir, 448);
  history_file = open (history_path, O_RDWR | O_CREAT, 420);
  if (history_file == -1)
	{
	  fprintf (stderr, "Error opening history file!\n");
	  exit (1);
	}

  lseek (history_file, 0, SEEK_SET);
  read_line[0] = '\0';
  read_char[0] = '\0';
  current_command = 0;
  while (read (history_file, read_char, 1) != 0
		 && current_command < COMMANDS_NUMBER)
	{
	  read_char[1] = '\0';
	  if (read_char[0] == '\n' && read_line[0] != '\0')
		{
		  read_line[cur_char] = '\0';
		  strcpy (command_history[current_command], read_line);
		  current_command++;
		  read_line[0] = '\0';
		  cur_char = 0;
		}
	  else
		{
		  read_line[cur_char] = read_char[0];
		  cur_char++;
		}
	  cur_file_pos++;
	  lseek (history_file, cur_file_pos, SEEK_SET);
	}
  commands_count = current_command;
  close (history_file);
  free (read_char);
  free (read_line);
}

void
saveHistory (void)
{
  int		history_file;

  history_file = open (history_path, O_RDWR | O_CREAT | O_TRUNC);
  if (history_file == -1)
	{
	  fprintf (stderr, "Error opening history file!\n");
	  exit (1);
	}

  lseek (history_file, 0, SEEK_SET);
  current_command = 0;
  while (current_command <= commands_count)
	{
	  write (history_file, command_history[current_command],
			 strlen (command_history[current_command]));
	  write (history_file, "\012", 1);
	  current_command++;
	}
  close (history_file);
}
