#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xlibint.h>
#include <WINGs/WINGs.h>
#include <WINGs/WINGsP.h>
#include <WINGs/WUtil.h>
#include <WMaker.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/fcntl.h>
#include <locale.h>
#include <pwd.h>

#include "utils.h"

#define COMMANDS_NUMBER 20

/* X's vars */
Display         *display;

/* App's vars */
WMScreen        *wm_screen;
WMInputPanel    *CommandPanel;
WMAppContext    *app;
WMUserDefaults  *udb;

WMMenu        *mainmenu;
WMMenu        *info_submenu;
WMMenu        *edit_submenu;
WMMenu        *windows_submenu;
WMMenu        *services_submenu;

typedef struct {
  WMWindow    *window;
  WMRange     text_range;
  WMLabel     *icon_label;
  WMPixmap    *icon_pixmap;
  WMFrame     *hr_line;
  WMLabel     *title;
  WMFont      *title_font;
  WMLabel     *info;
  WMLabel     *info_user;
  WMLabel     *username_prompt;
  WMTextField *username_tf;
  WMLabel     *command_prompt;
  WMTextField *command_tf;
  WMButton    *run_button;
  WMButton    *cancel_button;
  WMButton    *switch_button;
  WMLabel     *auth_prompt;
  WMTextField *auth_password;
  WMButton    *auth_ok_button;
  WMButton    *auth_cancel_button;
  WMList      *varlist;
} _LaunchPanel;
_LaunchPanel	*LaunchPanel;

int           commands_number;
char          *entered_text;
char          *command_history[COMMANDS_NUMBER];
char          *home_var;
char          *path;
char          *history_path;
int           current_command;
int           commands_count;
char          *entered_user;
int           auth;
int           auth_result;
struct passwd *pw;
int           su;
extern char   **environ;
char          *variants[255];
char          *leader_text, *leader_tmp, *complete_text;
int           nvariants, tabkeypress;

void loadHistory (void);
void saveHistory (void);
void runCommand (void);
void runExecPanel (void);
void runAuthPanel (void);
void runInfoPanel (void);
void runLegalPanel (void);
void runPreferencesPanel (void);

/* common_panel.c*/
void createCommonPanel (void);
void configureCommonPanel (void);

/* launch.c */
void LaunchCloseAction (void);
void LaunchAbortAction (void);
char *KeyPressAction (XEvent *event, WMWidget *widget);
void authOkAction (void);

int testFile (char *test_pathname);
int makeCompletion (void);
int ConsoleSwitchVisible;
int ConsoleApp;
