/*
 *	Legal Panel
 */

#include "launch.h"

static int LegalPanelRunning = 0;

typedef struct
{
  WMWindow *window;
  WMLabel  *legal_label;
}_LegalPanel;

static _LegalPanel *LegalPanel;

/***************************************/

static void
closeLegalPanel (void)
{
  WMUnmapSubwidgets (LegalPanel->window);
  WMUnmapWidget (LegalPanel->window);
  WMDestroyWidget (LegalPanel->window);
  LegalPanelRunning = 0;
  free (LegalPanel);
}

void
runLegalPanel (void)
{
  int x, y;

  if (LegalPanelRunning == 1)
	return;
  LegalPanelRunning = 1;

  LegalPanel = (_LegalPanel *) malloc (sizeof (_LegalPanel));

  LegalPanel->window = WMCreatePanelWithStyleForWindow (LaunchPanel->window,
														"Legal", 
														WMClosableWindowMask 
														| WMTitledWindowMask);
  WMSetWindowTitle (LegalPanel->window, "Legal");
  WMResizeWidget (LegalPanel->window, 420, 250);
  WMSetWindowMaxSize (LegalPanel->window, 420, 250);
  WMSetWindowMinSize (LegalPanel->window, 420, 250);
  WMSetWindowCloseAction (LegalPanel->window, (WMAction *) closeLegalPanel, NULL);
  WMSetWindowLevel(LegalPanel->window, WMModalPanelWindowLevel);

  x = (WidthOfScreen (DefaultScreenOfDisplay (display)) -
	   WMWidgetWidth (LegalPanel->window)) / 2;
  y = (HeightOfScreen (DefaultScreenOfDisplay (display)) -
	   WMWidgetHeight (LegalPanel->window)) / 2;
  WMSetWindowInitialPosition (LegalPanel->window, x, y);
  WMMoveWidget (LegalPanel->window, x, y);


  LegalPanel->legal_label = WMCreateLabel (LegalPanel->window);
  WMResizeWidget (LegalPanel->legal_label, 404, 234);
  WMMoveWidget (LegalPanel->legal_label, 8, 8);
  WMSetLabelWraps(LegalPanel->legal_label, True);
  WMSetLabelTextAlignment (LegalPanel->legal_label, WALeft);
  WMSetLabelText (LegalPanel->legal_label,
		  "     Launch.app is free software; you can redistribute it and/or\n"
		  " modify it under the terms of the GNU General Public License as\n"
		  " published by the Free Software Foundation; either version 2 of the\n"
		  " License, or (at your option) any later version.\n\n"
		  "     Launch.app is distributed in the hope that it will be useful,\n"
		  " but WITHOUT ANY WARRANTY; without even the implied warranty\n"
		  " of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.\n"
		  " See the GNU General Public License for more details.\n\n"
		  "     You should have received a copy of the GNU General Public\n"
		  " License along with this program; if not, write to the Free Software\n"
		  " Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA\n"
		  " 02111-1307, USA.");
  WMSetLabelRelief(LegalPanel->legal_label, WRGroove);
	
  WMRealizeWidget (LegalPanel->window);
  WMMapSubwidgets (LegalPanel->window);
  WMMapWidget (LegalPanel->window);
}
