/*
 *	Is it file? Is it executable? etc.
 */

#include "launch.h"
#include <dirent.h>
#include <sys/types.h>

int
testFile (char *test_pathname)
{
  struct stat   filestatus;
  char          *textfieldtext, *testname, *tmptext, *tmppath;
  char          *searchpath[32];
  int           npath, i, j;
  int           perm_ok = 0;
  int           srch_ok = 0;

  if (!strlen (entered_text))	// Text field is empty
	return (2);

  textfieldtext =
	(char *) malloc (strlen (test_pathname) + strlen (home_var) + 2);
  strcpy (textfieldtext, test_pathname);

  // Input text isn`t a directory, search by PATH
  if (strncmp ("/", textfieldtext, 1) && strncmp ("~", textfieldtext, 1))
	{
	  if (strlen (path) == 0)
		{
		  free (textfieldtext);	// Variable PATH empty ?
		  return (2);
		}
	  tmppath = (char *) malloc (strlen (path) + 1);
	  strcpy (tmppath, path);
	  i = 0;
	  npath = 0;
	  searchpath[0] = tmppath;
		
	  while (path[i])		// Replace ":" on "\0"
		{
		  if (tmppath[i] == ':')
			tmppath[i] = '\0';
		  i++;
		}
	  i = 0;
		
	  while (path[i])		// Create PATH array
		{
		  if (!tmppath[i])
			{
			  npath++;
			  searchpath[npath] = tmppath + i + 1;
			  for (j = 0; j < npath; j++)	// Search double PATH
				{
				  if (!strcmp (searchpath[j], searchpath[npath]))
					{
					  npath--;
					  continue;
					}
				}
			}
		  i++;
		}
		
	  for (i = 0; i <= npath; i++)	// Search programs in PATH
		{
		  testname =
			(char *) malloc (strlen (searchpath[i]) + strlen (textfieldtext) + 2);
		  strcpy (testname, searchpath[i]);
		  strcpy (testname + strlen (searchpath[i]), "/");
		  strcpy (testname + strlen (searchpath[i]) + 1, textfieldtext);
		  if (!stat (testname, &filestatus)
			  && !(filestatus.st_mode & S_IFDIR))
			{
			  srch_ok = 1;
			  if (filestatus.st_mode & S_IXUSR
				  && filestatus.st_uid == getuid ())
				perm_ok = 1;
			  else if (filestatus.st_mode & S_IXOTH)
				perm_ok = 1;
			  else
				if (filestatus.st_mode & S_IXGRP && filestatus.st_gid == getgid ())
				  perm_ok = 1;
			}
		  free (testname);
			
		  if (perm_ok)
			{
			  free (tmppath);
			  free (textfieldtext);
			  return (0);
			}
		}
	  free (tmppath);
	  free (textfieldtext);
	  if (!srch_ok)
		return (3);		// Command not found.
	  return (1);		// Permission denied.
	}
  else				// Input text is a directory, search by text.
	{
	  if (!strncmp ("~", textfieldtext, 1))	// '~' entered ?
		{
		  tmptext = (char *) malloc (strlen (textfieldtext));
		  strcpy (tmptext, textfieldtext + 1);
		  strcpy (textfieldtext, home_var);
		  strcpy (textfieldtext + strlen (home_var), "/");
		  strcpy (textfieldtext + strlen (home_var) + 1, tmptext);
		  free (tmptext);
		}
	  if (!stat (textfieldtext, &filestatus) && !(filestatus.st_mode & S_IFDIR))
		{
		  srch_ok = 1;
		  if (filestatus.st_mode & S_IXUSR && filestatus.st_uid == getuid ())
			perm_ok = 1;
		  else if (filestatus.st_mode & S_IXOTH)
			perm_ok = 1;
		  else if (filestatus.st_mode & S_IXGRP && filestatus.st_gid == getgid ())
			perm_ok = 1;
		}
		
	  free (textfieldtext);
	  if (!srch_ok)
		return (3);		// Command not found.
	  if (perm_ok)
		return (0);
	  return (1);		// Permission denied.
	}
}
